#version 150 compatibility
#include "const.glsl"
#include "../sampleFetch.glsl"
#include "computeAO.glsl"

uniform sampler2D normalIDMap;
uniform sampler2D mvPosMap;
uniform mat4 In_ProjectionMatrix;

uniform float radius;
uniform float bias;
uniform float darkness;
uniform int stepCount;

uniform sampler2D SamplesTexture;
uniform int SamplesNumber; //SamplesNumber
uniform int PatternSize;  //PatternSize

out vec4 FragColor[1];


void main (void) {
    vec4 n = texture (normalIDMap, gl_TexCoord[0].st);
    if (n.w < 0.5){
		FragColor[0] = vec4(1);
		return;	
	}
    vec4 p = texture (mvPosMap, gl_TexCoord[0].st);
    
    int k = 1 * (int(gl_FragCoord.x)  % int(PatternSize)) + int(PatternSize) * (int (gl_FragCoord.y) % int (PatternSize));
    int patternIndex = (k * int (SamplesNumber));	
    vec2 offset = getSample(patternIndex, SamplesTexture).xy;
    
	float ao = marchDoubleRay(p, n, vec2(offset), stepCount, radius, 0, bias, mvPosMap, In_ProjectionMatrix);
	
	FragColor[0] = vec4 (1 - ao * darkness); //horizontal
}