#version 330 compatibility

uniform sampler2D input;
uniform int steps;
uniform float variance;
const float pi = 3.1415926;

float square(float a)
{
	return a * a;
}


float gaussian(float x, float variance2, float u)
{
	float a = 1.0/sqrt(2 * pi * variance2);
	float b = exp( -square(x-u)/(2*variance2));
	return a * b;
}


vec4 gaussianFilter(int steps, sampler2D textureMap, float variance2)
{
	vec4 sum = vec4(0);
	float weightSum = 0;
	//ivec2 lowPos = ivec2(-steps/2);
    for(int i = 0; i <  steps;++i ){
        float isqr = float(i*i);
        for(int j =  0; j <  steps; ++j ){
        
            ivec2 cordinate = ivec2(gl_FragCoord.xy) + ivec2(i,j);// + lowPos;
            vec4 tex = texelFetch(textureMap,cordinate, 0);
			float weight = gaussian( sqrt(float(i*i + j*j))/float(steps), variance2, 0);
            sum += tex * weight;
            weightSum += weight; 
        }
    }
	sum /= weightSum;
	return sum;
}

void main (void) {

    gl_FragColor = gaussianFilter(steps, input, variance * variance);
    
}

