#version 330 compatibility

uniform sampler2D input;
uniform int steps;


float square(float a)
{
	return a * a;
}

float wendland(float h, float t){
	float thinvers = t/h;
	return (float(t < h) * square (square(1-thinvers))*(4*thinvers+1));
}


vec4 wendlandFilter(int steps, sampler2D textureMap)
{
	vec4 sum = vec4(0);
	float weightSum = 0;
	//ivec2 lowPos = ivec2(-steps/2);
    for(int i = 0; i <  steps;++i ){
        float isqr = float(i*i);
        for(int j =  0; j <  steps; ++j ){
        
            ivec2 cordinate = ivec2(gl_FragCoord.xy) + ivec2(i,j); //+ lowPos;
            vec4 tex = texelFetch(textureMap,cordinate, 0);
			float weight = wendland(1, sqrt(float(i*i + j*j))/float(steps));
            sum += tex * weight;
            weightSum += weight; 
        }
    }
	sum /= weightSum;
	return sum;
}

void main (void) {

    gl_FragColor = wendlandFilter(steps, input);

}

